<?

##
## mailbox.php3
##
## IMP v1.1
## Copywrite 1998 Charles J. Hagenbuch <chuck@osmos.ml.org>
##
## This code is under the GNU Public License
## See the file COPYING in this directory
##
  
  error_reporting(1);           # surpress imap_stream errors, etc.
  require ('imp.lib');          # IMPlib is the IMP function library
  dl($path_to_imap);            # load the imap module
  header("Expires: 120");       # make the page expire in 2 minutes
  
  # Set or read cookies
  if ($action != "login") {
    $user    = getuser();
    $pass    = getpass();
    $folders = getfldr();
    $server  = getsrvr();
  } else {
    setuser($user);
    setpass($pass);
    $server  = setsrvr($server);
    $folders = setfldr($folders);
  }
  
  if (!isset($mailbox)) { $mailbox = 'INBOX'; }
  if (!isset($start)) { $start = 1; }
  $current_mbox = eregi_replace("{$server}$folders/*", "", $mailbox);
  
  # only proceed on a valid login
  $mbox = validate_login($server, $mailbox, $user, $pass);
  
  
  # Run through the action handlers
  if (isset($action)) {
  
    if (substr($indices, -0, 1) == ',') {
      $indices = substr($indices, 0, strlen($indices) -1);
    }
    
    if ( ($action == 'delete') && ($indices) && ($mailbox) ) {
      $indices = split(',', $indices);
      for ($i = 0; $i < count($indices); $i++) {
        if (!(imap_delete($mbox, $indices[$i]))) {
          $errormsg = '<tr><th colspan=5>An error occured; some or all of your messages have not been deleted.</th></tr>';
	}
      }
    
    } elseif ( ($action == "undelete") && ($mailbox) && ($indices) ) {
      $indices = split(",", $indices);
      for ($i = 0; $i < count($indices); $i++) {
        if (!(imap_undelete($mbox, $indices[$i]))) {
          $errormsg = "<tr><th colspan=5>An error occured; some or all of your messages were not undeleted</th></tr>";
        }
      }
    
    } elseif ( ($action == "move") && ($target) && ($indices) ) {
      if (! (imap_mail_move($mbox, $indices, $target)) ) {
        $errormsg = "<tr><th colspan=5>An error occured; some or all of your messages were not moved.</th></tr>\n";
      }
    
    } elseif ( ($action == "copy") && ($target) && ($indices) ) {
      if (!(imap_mail_copy($mbox, $indices, $target)) ) {
        $errormsg = "<tr><th colspan=5>An error occured; some or all of your messages were not copied.</th></tr>\n";
      }
    
    } elseif ( ($action == "expunge") && ($mailbox) ) {
      if (!(imap_expunge($mbox))) {
        $errormsg = "<tr><th colspan=5>An error occured; the mailbox was not expunged</th></tr>";
      }
    
    } elseif ($action == "login") {
      echo "<script language=\"JavaScript\">
            <!--
	    if (parent.impmenu) {
	      parent.impmenu.location=\"menu.php3\";
	    }
	    //-->
	    </script>";
    }
  }
  
?>

<html>
<head>
<title> Index of <? echo $current_mbox; ?> </title>
</head>

<body bgcolor=e9e9e9 text=000000 link=0000ff vlink=0000aa alink=0000ff>

<noscript>
<p><b>IMP requires JavaScript to perform certain message handling functions</b></p>
</noscript>

<table border=0 width="100%"><tr><td align=center>
<table border=0 width="95%" cellpadding=3 cellspacing=2>

<? echo $errormsg; ?>

<tr><td colspan=5 bgcolor=002266 align=center>
<table border=0 width="100%" cellpadding=0 cellspacing=0><tr>

<?
  $nummsgs = imap_num_msg($mbox);
  
  if ($nummsgs < 100) { $start = 1; }
  elseif ($nummsgs - $start < 100) { $start = $nummsgs - 100; }
  
  if ($nummsgs < $start + 100) { $end = $nummsgs; }
  else { $end = $start + 100; }
  
  /* figure out whether to include the prev/next page links or not, and if so,
   * what to index them at. */
  
  if ($nummsgs > 100) {
    if ($start > 1) {
      if ($start - 100 >= 1) { $prevstart = $start - 100; }
      else { $prevstart = 1; }
      $mailbox_navigation .= "<a href=\"mailbox.php3?mailbox=$mailbox&start=$prevstart\">previous page</a> ";
    }
    if ($start + 100 < $nummsgs) {
      $nextstart = $start + 100;
      $mailbox_navigation .= "<a href=\"mailbox.php3?mailbox=$mailbox&start=$nextstart\">next page</a> ";
    }
  }
  
  $check=imap_check($mbox);
  
  echo "<td align=left width=\"33%\"><font color=ffffff><b>$current_mbox</b></font></td>\n";
  echo "<td align=center width=\"33%\"><font color=ffffff><i>",substr($check->Date, 0, 11),"</i></font></td>\n";
  echo "<td align=right width=\"33%\"><font color=ffffff><b>$start - $end of $nummsgs Messages, ";
  echo $check->Recent," Recent</b></font></td>\n";
?>

</tr></table></td></tr>

<tr><td bgcolor=dcdcdc>&nbsp;</td><td bgcolor=dcdcdc colspan=4>
  <table border=0 width="100%"><tr><td align=left>
    <font face="Arial,Helvetica" size=2>
    <a href="javascript:Submit('delete')">[Delete]</a> 
    <a href="javascript:Submit('undelete')">[Undelete]</a> 
    selected mail
    </font>
  </td>
  
  <form name=transfer1 action="mailbox.php3" method=post>
  
  <?
  $mboxes = imap_listmailbox($mbox, "{$server}", "$folders/*");
  
  $options  = "<option value=\"\">selected mail to:</option>\n";
  if ($mailbox != "INBOX") { $options .= "<option value=\"INBOX\">Inbox</option>\n"; }
  for ($i = 1; $i < count($mboxes); $i++) {
    $label = eregi_replace("{$server}$folders/*", "", $mboxes[$i]);
    if ($mailbox != $mboxes[$i]) { $options .= "<option value=\"$mboxes[$i]\">$label</option>\n"; }
  }
  ?>
  
  <td align=right>
    <font face="Arial,Helvetica" size=2>
    
    <a href="javascript:Transfer('move', 1)">[Move]</a>
    <a href="javascript:Transfer('copy', 1)">[Copy]</a> 
    <select name=target>
    <? echo $options,"\n"; ?>
    </select>
    
    </font>
  </td>
  
  <? echo "<input type=hidden name=mailbox value=\"$mailbox\">\n"; ?>
  <input type=hidden name=action value="">
  <input type=hidden name=indices value="">
  </form>
  
  </tr></table>
</td></tr>

<tr><td bgcolor=ffffff>&nbsp;</td><td bgcolor=ffffff colspan=3>
  <table border=0 width="100%"><tr><td width="33%" align=left>
    <font face="Arial,Helvetica" size=2>
    <a href="javascript:ToggleAll(true)">select all</a> - 
    <a href="javascript:ToggleAll(false)">select none</a>
    </font>
  </td><td width="33%" align=center>
    <font face="Arial,Helvetica" size=2>
    <? echo $mailbox_navigation,"\n"; ?>
    </font>
  </td><td width="33%" align=right>
    <font face="Arial,Helvetica" size=2>
    <? echo "<a href=\"mailbox.php3?action=expunge&mailbox=$mailbox\">empty trash</a>\n"; ?>
    </font>
  </td></tr></table>
</td><td bgcolor=ffffff>&nbsp;</td></tr>

<tr>
<th bgcolor=ffffcc align=left>&nbsp;</th>
<th bgcolor=ffffcc align=left><font face="Arial,Helvetica">Date&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</font></th>
<th bgcolor=ffffcc align=left><font face="Arial,Helvetica">From</font></th>
<th bgcolor=ffffcc align=left><font face="Arial,Helvetica">Subject</font></th>
<th bgcolor=ffffcc width=10><font face="Arial,Helvetica">Del?</font></th>
</tr>

<form action="mailbox.php3" method=post name=messages>

<?
  $file = file("templates/mailbox.php3-message_summaries.inc");
  $file = implode($file, "\n");
  
  for ($i=$start; $i <= $end; $i++) {
    if (! imap_ping($mbox) ) {
      $mbox = imap_open("{$server}$mailbox","$user","$pass");
    }
    
    $h=imap_header($mbox,$i);
    
    $dat = chop(substr(htmlentities($h->date), 0, 11));
    $frm = chop(htmlentities($h->fromaddress));
    $sub = chop(htmlentities($h->subject));
    
    if ($dat == "") { $dat = "&nbsp;"; }
    if ($frm == "") { $frm = "&nbsp;"; }
    if ($sub == "") { $sub = "[no subject]"; }
    
    fill_template($file, "\$dat, \$frm, \$sub, \$h, \$i, \$mailbox");
  }
  echo "<input type=hidden name=mailbox value=\"$mailbox\">\n";
?>

<input type=hidden name=action value="">
<input type=hidden name=indices value="">
</form>

<tr><td bgcolor=ffffff>&nbsp;</td><td bgcolor=ffffff colspan=3>
  <table border=0 width="100%"><tr><td width="33%" align=left>
    <font face="Arial,Helvetica" size=2>
    <a href="javascript:ToggleAll(true)">select all</a> - 
    <a href="javascript:ToggleAll(false)">select none</a>
    </font>
  </td><td width="33%" align=center>
    <font face="Arial,Helvetica" size=2>
    <? echo $mailbox_navigation,"\n"; ?>
    </font>
  </td><td width="33%" align=right>
    <font face="Arial,Helvetica" size=2>
    <? echo "<a href=\"mailbox.php3?action=expunge&mailbox=$mailbox&server=$server\">empty trash</a>\n"; ?>
    </font>
  </td></tr></table>
</td><td bgcolor=ffffff>&nbsp;</td></tr>

<tr><td bgcolor=dcdcdc>&nbsp;</td><td bgcolor=dcdcdc colspan=4>
  <table border=0 width="100%"><tr><td align=left>
    <font face="Arial,Helvetica" size=2>
    <a href="javascript:Submit('delete')">[Delete]</a> 
    <a href="javascript:Submit('undelete')">[Undelete]</a> 
    selected mail
    </font>
  </td>
  
  <form name=transfer2 action="mailbox.php3" method=post>
  
  <?
  $mboxes = imap_listmailbox($mbox, "{$server}", "$folders/*");
  
  $options  = "<option value=\"\">selected mail to:</option>\n";
  if ($mailbox != "INBOX") { $options .= "<option value=\"INBOX\">Inbox</option>\n"; }
  for ($i = 1; $i < count($mboxes); $i++) {
    $label = eregi_replace("{$server}$folders/*", "", $mboxes[$i]);
    if ($mailbox != $mboxes[$i]) { $options .= "<option value=\"$mboxes[$i]\">$label</option>\n"; }
  }
  ?>
  
  <td align=right>
    <font face="Arial,Helvetica" size=2>
    
    <a href="javascript:Transfer('move', 2)">[Move]</a>
    <a href="javascript:Transfer('copy', 2)">[Copy]</a>&nbsp;
    <select name=target>
    <? echo $options,"\n"; ?>
    </select>
    
    </font>
  </td>
  
  <? echo "<input type=hidden name=mailbox value=\"$mailbox\">\n"; ?>
  <input type=hidden name=action value="">
  <input type=hidden name=indices value="">
  </form>
  
  </tr></table>
</td></tr>

</table>
</td></tr></table>

<? imap_close($mbox); ?>

</body>
</html>

<script language="JavaScript">
<!--

function Transfer(action, form) {
  if (form == 1) {
    document.transfer1.indices.value = '' + WhichChecked();
    document.transfer1.action.value = action;
    document.transfer1.submit();
  } else {
    document.transfer2.indices.value = '' + WhichChecked();
    document.transfer2.action.value = action;
    document.transfer2.submit();
  }
}

function Submit(action) {
  document.messages.indices.value = '' + WhichChecked();
  document.messages.action.value = action;
  document.messages.submit();
}

function ToggleAll(checked) {
  len = document.messages.elements.length;
  var i=0;
  for(i=0; i < len; i++) {
    if (document.messages.elements[i].name=='message') {
      document.messages.elements[i].checked=checked;
    }
  }
}

function WhichChecked() {
  len = document.messages.elements.length;
  var i=0;
  var selected="";
  for(i=0; i < len; i++) {
    if ( (document.messages.elements[i].name=='message') && (document.messages.elements[i].checked) ) {
      selected += document.messages.elements[i].value + ",";
    }
  }
  return selected;
}

//-->
</script>
